/**
 * 
 */
package arraybag;

import student.TestCase;

/**
 * @author maellis1
 * @version Jun 22, 2015
 *
 */
public class ArrayBag1Test extends TestCase {

    ArrayBag1<String> bag1;
    ArrayBag1<String> bag2;
    String[] results;
    String[] results2;

    public void setUp() {
        bag1 = new ArrayBag1<String>();
        bag2 = new ArrayBag1<String>(4);
    }


    public void testAdd() {

        bag1.add("first entry");

        bag2.add("bag2 item 1");
        bag2.add("bag2 item 2");
        bag2.add("bag2 item 3");
        bag2.add("bag2 item 4");
        assertFalse(bag2.add("bag2 item 5"));

        results = new String[1];
        String[] bagContents = bag1.toArray(results);

        assertEquals(bag1.getCurrentSize(), 1);
        assertEquals(bagContents.length, 1);

        assertEquals("first entry", bagContents[0]);

        results2 = new String[4];
        String[] strings2 = bag2.toArray(results2);
        for (int i = 0; i < bag2.getCurrentSize(); i++) {
            assertEquals("bag2 item " + (i + 1), strings2[i]);
        }

    }


    public void testToArray() {
        results = new String[25];
        for (int i = 0; i < 25; i++) {
            bag1.add("entry number " + i);
        }

        String[] entries = bag1.toArray(results);
        assertEquals(25, bag1.getCurrentSize());
        assertEquals(25, entries.length);
        for (int i = 0; i < 25; i++)
            assertEquals("entry number " + i, entries[i]);

    }

}
